(***********************************************************************)
(*                                                                     *)
(*                              My_stdlib                              *)
(*                                                                     *)
(*             projets Estime & Cristal, INRIA-Rocquencourt            *)
(*                                                                     *)
(*  Copyright 2004-2006 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: printer.mli,v 1.1 2007/01/17 23:36:00 fclement Exp $ *)

type 'a t = Buffer.t -> 'a -> unit;;
(** The type of printers on buffers. *)

type 'a printer = 'a t;;
(** An alias for the type of printers on buffers. *)

val set_max_iprint : int -> unit;;
val get_max_iprint : unit -> int;;
(** To set and get the maximum number of elements to print for compact printing
    of multi-element values. *)

val print_same_elements : int ref -> int ref -> 'a -> 'a t -> 'a ref t;;
val print_same_last_elements : int ref -> int ref -> 'a t -> 'a ref t;;
(** Generic printers for compact printing of multi-element values. *)
